postfix + pgsql + dovecot + postfixadmin example configuration.


==Конфигурирование связки postfix + pgsql + dovecot + postfixadmin==

===postfix===
 main.cf
%%
myhostname = xxx.xxx.tld
mydestination = nonexsistent.domain

virtual_alias_maps = pgsql:/etc/postfix/pgsql_virtual_alias_maps.cf
virtual_gid_maps = static:12
virtual_mailbox_base = /var/spool/vmail
virtual_mailbox_domains = pgsql:/etc/postfix/pgsql_virtual_domains_maps.cf
virtual_mailbox_maps = pgsql:/etc/postfix/pgsql_virtual_mailbox_maps.cf
virtual_minimum_uid = 1150
virtual_uid_maps = static:1150

smtpd_sasl_type = dovecot
smtpd_sasl_path = private/auth
smtpd_sasl_auth_enable = yes
smtpd_sasl_authenticated_header = yes

smtpd_helo_restrictions = permit_sasl_authenticated, permit_mynetworks

smtpd_client_restrictions = permit_sasl_authenticated, permit_mynetworks

smtpd_recipient_restrictions = permit_mynetworks
    permit_sasl_authenticated
    reject_unauth_destination
%%

/etc/postfix/pgsql_virtual_alias_maps.cf
%%
user = postfix
password = xxx
hosts = 127.0.0.1
dbname = postfix
table = alias
select_field = goto
where_field = address
%%

/etc/postfix/pgsql_virtual_domains_maps.cf
%%
user = postfix
password = xxx
hosts = 127.0.0.1
dbname = postfix
table = domain
select_field = domain
where_field = domain
additional_conditions = and backupmx = '0' and active = '1'
%%

/etc/postfix/pgsql_virtual_mailbox_maps.cf
%%
user = postfix
password = xxx
hosts = 127.0.0.1
dbname = postfix
table = mailbox
select_field = maildir
where_field = username
%%

===postfixadmin===
По дефолту postfixadmin задаёт maildir вида user@domain, нам же требуется domain/user
%%
$CONF['domain_path'] = 'YES';
$CONF['domain_in_mailbox'] = 'NO';
%%

===dovecot===
dovecot.conf:
%%
protocols = imap imaps pop3 pop3s
disable_plaintext_auth = no
ssl_cert_file = /var/lib/ssl/certs/dovecot.cert
ssl_key_file = /var/lib/ssl/private/dovecot.key
mail_privileged_group = mail
lock_method = fcntl
valid_chroot_dirs = /var/spool/vmail
protocol imap {
}

protocol pop3 {
}
protocol lda {
  postmaster_address = postmaster@example.com
}
auth default {
  mechanisms = plain
 passdb sql {
   args = /etc/dovecot/dovecot-pgsql.conf
 }
  userdb sql {
    args = /etc/dovecot/dovecot-pgsql.conf
  }
  user = root
  socket listen {
    client {
      path = /var/spool/postfix/private/auth
      mode = 0660
      user = postfix
      group = postfix
    }
  }
}
dict {
}
plugin {
}
%%

 /etc/dovecot/dovecot-pgsql.conf
%%
driver = pgsql
connect = host=127.0.0.1 dbname=postfix user=postfix password=EeZeit1chai5
default_pass_scheme = MD5

user_query = SELECT '/var/spool/vmail/%d/%n' as home, 'maildir:/var/spool/vmail/%d/%n'as mail, 1150 AS uid, 12 A
S gid, 'dirsize:storage=' || 'quota' AS quota FROM mailbox WHERE username = '%u' AND active = '1'

password_query = SELECT username as user, password, '/var/spool/vmail/%d/%n' asuserdb_home, 'maildir:/var/spool/
vmail/%d/%n' as userdb_mail, 1150 as userdb_uid, 12 asuserdb_gid FROM mailbox WHERE username = '%u' AND active =
'1'
%%

===Создание юзера и mail storage:===
%%
useradd -r -u 1150 -g mail -d /var/spool/vmail -s /sbin/nologin -c 'Virtual Mailbox' vmail
mkdir -p /var/spool/vmail
chown vmail:mail /var/spool/vmail
chmod 770 /var/spool/vmail
%%
